#undef _NON_BLOCKING_
#include "config.h"
#include "flop_table.h"

module ccs_qcd_solver_bench_class
  use lattice_class
  implicit none
  private
  public :: bicgstab_hmc
  public :: init_u_and_y
  public :: clover, clvinv
  public :: mult_mb_pre
  public :: initset, output
  public :: flop_count_clover
  public :: flop_count_clvinv 
  public :: assign_inv_mult_wd
  public :: write_config
  public ::  read_config
  integer(8), parameter :: NSITE=NX*NY*NZ*NTH

  integer(8), parameter :: &
  flop_count_clover = 198_8*4_8*(NX1*NY1*NZ*NT+NX1*NY*NZ1*NT+NX1*NY*NZ*NT1  &
 &                                            +NX*NY1*NZ1*NT+NX*NY1*NZ*NT1  &
 &                                                          +NX*NY*NZ1*NT1) &
 &                            +846_8*NX*NY*NZ*NT*6_8+72_8*NX*NY*NZ*NT*6_8
  integer(8), parameter :: flop_count_clover_f1f2 = (12_8+24_8)*9_8*2_8*NTH*NZ*NY*NX
  integer(8), parameter :: flop_count_clvinv_ldl =  &
 &                        8_8*CLSP/2*15_8*NSITE+(2_8*CLSP/2 + 1_8)    *NSITE  &
 &                                             +(2_8*CLSP/2 + 1_8)*5_8*NSITE  &
 &                                                   + 8_8*CLSP/2*15_8*NSITE  &
 &                           + 5_8*NSITE*15_8+10_8*NSITE*20_8+2_8*NSITE*15_8
  integer(8), parameter :: flop_count_full2linear_clv = 21_8*2_8*2_8*NSITE
  integer(8), parameter :: flop_count_clvinv = &
 &  (flop_count_clover_f1f2+flop_count_clvinv_ldl*2+flop_count_full2linear_clv)*2

contains

#include "bicgstab_hmc.h90"
#include "clover.h90"
#include "clover_f1f2.h90"
#include "clvinv.h90"
#include "clvinv_ldl.h90"
#include "copy_u.h90"
#include "copy_y.h90"
#include "expp_u.h90"
#include "full2linear_clv.h90"
#include "gauss_y.h90"
#include "init_p.h90"
#include "init_u_and_y.h90"
#include "initset.h90"
#include "mult.h90"
#include "mult_eo_tzyx.h90"
#include "mult_fclinv.h90"
#include "mult_mb_pre.h90"
#include "output.h90"
#include "xrand.h90"
#include "assign_inv_mult_wd.h90"

#include "fname_save.h90"
#include "read_write_config.h90"

end module
