#$Id: make.inc,v 1.2 2012/12/24 02:37:58 ishikawa Exp $

REVISION = -D_REVISION_='"$(shell cat ./.svnrevision)"'

#
# specify Fortran90 MPI compiler FC, compile options FFLAGS and linker options LDFLAGS
#

# example: Intel fortran, OpenMP enabled.
FC      = mpif90 -shared-intel -mcmodel=medium
FFLAGS  = -O3 -mavx -fPIC -align all -g -traceback -openmp -openmp-report2 -complex-limited-range -finline-limit=10000
#FFLAGS  = -O0 -mavx -fPIC -align all -g -traceback -openmp -openmp-report2 -complex-limited-range -finline-limit=10000
LDFLAGS = $(FFLAGS) -pie -openmp

# example: Intel fortran for Core2Duo CPU (-xT), OpenMP enabled.
#FC      = mpif90 -shared-intel -mcmodel=medium
#FFLAGS  = -O2 -xT -align all -g -traceback -openmp -openmp-report2 -complex-limited-range -finline-limit=10000
#LDFLAGS = $(FFLAGS) -openmp

# example: Intel fortran for general x86 (-xO, including AMD's CPUs), OpenMP enabled.
#FC      = mpif90 -shared-intel -mcmodel=medium
#FFLAGS  = -O2 -xO -align all -g -traceback -openmp -openmp-report2 -complex-limited-range -finline-limit=10000
#LDFLAGS = $(FFLAGS) -openmp

# example: GNU gfortran, OpenMP enabled.
#FC      = mpif90 -mcmodel=medium -funderscoring
#FFLAGS  = -O3 -ffixed-line-length-132 -march=core2 -msse3 -g -fopenmp
#LDFLAGS = $(FFLAGS)

LIBS = 

INCLUDE = -I./

RM	= /bin/rm -f
MV	= /bin/mv

.F90.o :

%.mod : %.F90
	$(FC) $(FFLAGS) $(REVISION) $(INCLUDE) -c $<

%.o : %.F90
	$(FC) $(FFLAGS) $(REVISION) $(INCLUDE) -c $<
